Subject: Re: bug#16737: Timed out waiting for reply from selection owner

From: Alex Bennée <[email-masked]>
Date: Fri, 05 Jun 2015 10:26:49 +0100

Oleh Krehel <[email-masked]> writes:

> Alex Bennée <[email-masked]> writes:
>
>> Tassilo Horn <[email-masked]> writes:
>>
>>> Alex Bennée <[email-masked]> writes:
>>>
>>>> I still see it and I've been tracking the emacs-24 branch. It seems to be a
>>>> consequence of a long lived Emacs daemon session
>>>
>>> I'm using the current master branch but I also use the server (which
>>> should be kind of the same to starting emacs as a doemon, no?).  Kill
>>> and yank for hours, and then out of sudden the timeouts appear.
>>
>> I haven't hit the problem for ages then suddenly this week as I was
>> pasting a URL it triggered again. Trouble is being able to get useful
>> diagnostics out when the problem hits.
>
> I tend to get this problem a lot more since I've switched from 24.5 to
> master.
>
> This code makes Emacs report the error immediately instead of freezing:
>
>     (setq x-selection-timeout 10)
>
> When the bug occurs, a fix that typically works is to:
>
> 1. kill some text while in Emacs.
> 2. copy the text from outside
> 3. wait for 3-4 seconds before attempting to paste into Emacs

I can't seem to unwedge without restarting Emacs. Anyway I attached gdb
and I'm confused by the failure. Sticking a breakpoints in:

  * x_get_foreign_selection:1242 (the error line)
  * x_handle_selection_notify

It seems we always see the timeout before the x_handle_selection_notify
is called. It seems to me it has got into a state where it's not
consuming events from X while waiting.

I've seen some cases where the timeout will be hit 4-5 times in a row
and then I'll see the same number of notify events.

>
> Step 3 could be important, since if I paste quickly, the bug seems to
> re-occur more often.
>
> Oleh

-- 
Alex Bennée